## nomacs 3.17.2282+dfsg

=== ImageLounge/CMakeLists.txt ===

# check cmake requirements
cmake_minimum_required (VERSION 3.0)

if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)

endif(COMMAND cmake_policy)

project(nomacs)

# needed for soname
set(NOMACS_VERSION_MAJOR 3)
set(NOMACS_VERSION_MINOR 17)
set(NOMACS_VERSION_PATCH 0)
set(NOMACS_VERSION ${NOMACS_VERSION_MAJOR}.${NOMACS_VERSION_MINOR})
set(NOMACS_FULL_VERSION ${NOMACS_VERSION}.${NOMACS_VERSION_PATCH})

if(CMAKE_CL_64)
	SET(NMC_ARCHITECTURE "x64")
else()
	SET(NMC_ARCHITECTURE "x86")
endif()

add_definitions(-DNOMACS_VERSION="${NOMACS_VERSION}")

set(BINARY_NAME ${CMAKE_PROJECT_NAME})
set(NOMACS_BUILD_DIRECTORY ${CMAKE_BINARY_DIR})

# if python is available, we can run additional build scripts (i.e. versioning)
find_package(Python QUIET)

# include macros needed
include("cmake/Utils.cmake")

set(QT5_MIN_VERSION 5.15.0)

# different compile options
option(ENABLE_OPENCV "Compile with Opencv (needed for RAW and TIFF)" ON)
option(ENABLE_RAW "Compile with raw images support (libraw)" ON)
option(ENABLE_TIFF "Compile with multi-layer tiff" ON)
option(ENABLE_QT_DEBUG "Disable Qt Debug Messages" ON)
option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" ON)
option(ENABLE_INCREMENTER "Run Build Incrementer" OFF)
option(ENABLE_TRANSLATIONS "Compile Translations" ON)
option(ENABLE_PLUGINS "Compile nomacs with plugin support" ON)
option(ENABLE_HEIF "Compile nomacs with HEIF support" OFF)
option(ENABLE_AVIF "Compile nomacs with AVIF support" OFF)
option(ENABLE_JXL "Compile nomacs with JPEG XL support" OFF)
option(ENABLE_CODE_COV "Run Code Coverage tests" OFF)
option(USE_SYSTEM_QUAZIP "QuaZip will not be compiled from source" ON) # ignored by MSVC

# Codecov
if (ENABLE_CODE_COV AND CMAKE_COMPILER_IS_GNUCXX)
    include("cmake/CodeCoverage.cmake")
    setup_target_for_coverage(${PROJECT_NAME}_coverage tests coverage)
endif()

if(APPLE)
	set(ENABLE_QUAZIP OFF)
	message(STATUS "QuaZip disabled - it's not supported on OSX")
endif()

# load paths from the user file if exists
if (EXISTS ${CMAKE_SOURCE_DIR}/CMakeUserPaths.cmake)
    include(${CMAKE_SOURCE_DIR}/CMakeUserPaths.cmake)

elseif (MSVC)

    set(DEPENDENCY_PATH "" CACHE STRING "Select the path where all dependencies are built")

    # windows needs some hints here...
    if (NOT "${DEPENDENCY_PATH}" STREQUAL "")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/exiv2/")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/opencv/")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/quazip/")
        set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} "${DEPENDENCY_PATH}/libraw/")
    endif()
endif()

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
elseif(NOT MSVC)
	message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()

if (ENABLE_CODE_COV AND CMAKE_COMPILER_IS_GNUCXX)
	# Codecov
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -pthread -g -O0 -fprofile-arcs -ftest-coverage")
endif()

# find Qt
NMC_FINDQT()

if (NOT ENABLE_QT_DEBUG)
	message (STATUS "disabling qt debug messages")
	add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif()

if(MSVC)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Win.cmake)
elseif(APPLE)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Mac.cmake)
elseif(UNIX)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
else()
	message(STATUS "build system unkown ... fallback to unix")
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
endif()

file(GLOB NOMACS_EXE_SOURCES "src/*.cpp")
file(GLOB NOMACS_EXE_HEADERS "src/*.h")

# gui
file(GLOB GUI_SOURCES "src/DkGui/*.cpp")
file(GLOB GUI_HEADERS "src/DkGui/*.h")

# core
file(GLOB CORE_SOURCES "src/DkCore/*.cpp")
file(GLOB CORE_HEADERS "src/DkCore/*.h")

# gather information for building
include_directories (
	${EXIV2_INCLUDE_DIRS}
	${LIBRAW_INCLUDE_DIRECTORY}
	${CMAKE_BINARY_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/src
	${CMAKE_CURRENT_SOURCE_DIR}/src/DkCore
	${CMAKE_CURRENT_SOURCE_DIR}/src/DkGui
	${TIFF_INCLUDE_DIR}
	${TIFF_CONFIG_DIR}
	${QUAZIP_INCLUDE_DIR}
	${QUAZIP_ZLIB_INCLUDE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/libqpsd	# needed for linux psd hack
	${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/drif
)

if (APPLE) # todo: somehow add this to Mac.cmake or MacBuildTarget.cmake
	execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_HEADERS OUTPUT_VARIABLE qt_install_headers)
	include_directories (BEFORE ${qt_install_headers})
	SET (NOMACS_SOURCES ${NOMACS_SOURCES} macosx/nomacs.icns)
endif (APPLE)

IF(NOT ENABLE_PLUGINS)
	LIST(REMOVE_ITEM GUI_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/DkPluginManager.cpp)
	LIST(REMOVE_ITEM GUI_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/src/DkPluginManager.h)
ENDIF(NOT ENABLE_PLUGINS)

# create version file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/DkCore/DkVersion.h.in ${CMAKE_CURRENT_BINARY_DIR}/DkVersion.h)

set(NOMACS_FORMS src/nomacs.ui)
set(NOMACS_RESOURCES src/nomacs.qrc)

file(GLOB NOMACS_TRANSLATIONS "translations/*.ts")

QT5_ADD_RESOURCES(NOMACS_RCC ${NOMACS_RESOURCES})

if (${ENABLE_TRANSLATIONS})
	QT5_ADD_TRANSLATION(NOMACS_QM ${NOMACS_TRANSLATIONS})
endif()

if(MSVC)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/WinBuildTarget.cmake)
elseif(APPLE)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/MacBuildTarget.cmake)
elseif(UNIX)
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/UnixBuildTarget.cmake)
else()
	message(STATUS "build system unkown ... fallback to unix")
	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/UnixBuildTarget.cmake)
endif()

# add build incrementer command if requested
if (ENABLE_INCREMENTER AND Python_FOUND)

    add_custom_command(
        TARGET ${DLL_CORE_NAME} PRE_BUILD 
        COMMAND ${Python_EXECUTABLE}
        ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionincrement.py 
        ${NOMACS_VERSION})

    message(STATUS "build incrementer enabled...")

endif()

if (Python_FOUND)
    
    add_custom_command(
        TARGET ${DLL_CORE_NAME} PRE_BUILD 
        COMMAND ${Python_EXECUTABLE}
        ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionupdate.py 
        ${CMAKE_BINARY_DIR}/DkVersion.h)

    # I am having issues with the PRE_BUILD above
    # if version increment is off, we just need to run the update once (for version won't change)
    # so let's do that:
    execute_process(COMMAND ${Python_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionupdate.py 
            ${CMAKE_BINARY_DIR}/DkVersion.h)

else()
    message(WARNING "Python not found: the version number will be incorrect!")
endif()


NMC_INSTALL()

NMC_COPY_FILES()

#debug for printing out all variables
# get_cmake_property(_variableNames VARIABLES)
# foreach (_variableName ${_variableNames})
#     message(STATUS "${_variableName}=${${_variableName}}")
# endforeach()

if(ENABLE_PLUGINS)

	if (NOT EXISTS ${PLUGINS_DIR})
		set(PLUGINS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
	else ()
		message(STATUS "${PLUGINS_DIR} is defined")
	endif()

	if (NOT EXISTS ${PLUGINS_DIR} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
		set(PLUGINS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/plugins")
	elseif (NOT EXISTS ${PLUGINS_DIR} AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../../nomacs-plugins/src")
		# set the snapcraft/flathub dir
		set(PLUGINS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../nomacs-plugins/src")
	endif ()

	if(EXISTS "${PLUGINS_DIR}/CMakeLists.txt")
		message(STATUS "using plugin directory: ${PLUGINS_DIR}")
		set(NOMACS_FOUND true)
		set(NOMACS_VARS_ALREADY_SET true)
		add_subdirectory(${PLUGINS_DIR} "${CMAKE_CURRENT_BINARY_DIR}/plugins")
	else()
		message(STATUS "I failed to locate plugins in: ${PLUGINS_DIR}")
		message(WARNING "plugins directory not found, not building plugins. You have to check out the nomacs-plugins git to the 'plugins' folder if you want to build them")
		SET(ENABLE_PLUGINS OFF)
	endif()
endif()

# get rid of VSCode warning (when using MSBuild)
# see: https://stackoverflow.com/questions/36451368/get-rid-of-cmake-warning-manually-specified-variables-were-not-used-by-the-proj/36452112
set(ignoreMe "${CMAKE_EXPORT_COMPILE_COMMANDS}")

# status
MESSAGE(STATUS "")
MESSAGE(STATUS "----------------------------------------------------------------------------------")
MESSAGE(STATUS " ${PROJECT_NAME} - Image Lounge ${NOMACS_VERSION}  <https://nomacs.org>")
execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_VERSION OUTPUT_VARIABLE qt_version)
message(STATUS " Qt version: ${qt_version}")


IF(OpenCV_FOUND)
    MESSAGE(STATUS " nomacs will be compiled with OPENCV support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with OPENCV support .................. NO")
ENDIF()

IF(LIBRAW_FOUND)
    MESSAGE(STATUS " nomacs will be compiled with LIBRAW support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with LIBRAW support .................. NO")
ENDIF()

IF(ENABLE_TIFF)
    MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... NO")
ENDIF()

IF(ENABLE_PLUGINS)
    MESSAGE(STATUS " nomacs will be compiled with plugin support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with plugin support .................. NO")
ENDIF()

IF(libheif_FOUND)
    MESSAGE(STATUS " nomacs will be compiled with HEIF support .................... YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with HEIF support .................... NO")
ENDIF()

IF(ENABLE_TRANSLATIONS)
    MESSAGE(STATUS " nomacs will be compiled with Translations .................... YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with Translations .................... NO")
ENDIF()

IF(ENABLE_QUAZIP)
    MESSAGE(STATUS " nomacs will be compiled with QuaZip support .................. YES")
ELSE()
    MESSAGE(STATUS " nomacs will be compiled with QuaZip support .................. NO")
ENDIF()

MESSAGE(STATUS "----------------------------------------------------------------------------------")

=== debian/changelog ===
nomacs (3.17.2282+dfsg-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:04:01 +1100

nomacs (3.17.2282+dfsg-2build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:04:55 +0000

nomacs (3.17.2282+dfsg-2) unstable; urgency=medium

  * Change team email to <team+lxqt@tracker.debian.org>

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 06 Sep 2023 22:10:36 +0800

nomacs (3.17.2282+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Add d/salsa-ci.yml for Salsa CI.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 06 Sep 2023 02:52:20 +0800

=== debian/control ===
Source: nomacs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: LXQt Packaging Team <team+lxqt@tracker.debian.org>
Uploaders: Alf Gaida <agaida@siduction.org>,
           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
           Andrew Lee (李健秋) <ajqlee@debian.org>
Section: graphics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               lcov,
               libexiv2-dev,
               liblcms2-dev,
               libopencv-dev,
               libqt5svg5-dev,
               libquazip5-dev,
               libraw-dev,
               libtiff-dev,
               libwebp-dev,
               qt5-qmake,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/lxqt-team/nomacs
Vcs-Git: https://salsa.debian.org/lxqt-team/nomacs.git
Homepage: https://nomacs.org/
Rules-Requires-Root: no

Package: nomacs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         qt5-image-formats-plugins
Breaks: libnomacscore3 (<< 3.6.1),
        libnomacsgui3 (<< 3.6.1),
        libnomacsloader3 (<< 3.6.1)
Replaces: libnomacscore3 (<< 3.6.1),
          libnomacsgui3 (<< 3.6.1),
          libnomacsloader3 (<< 3.6.1)
Recommends: nomacs-l10n (= ${source:Version})
Description: image viewer with capability of syncing multiple instances
 nomacs is a free image viewer for Windows and Linux systems, which is
 licensed under the GNU General Public License v3. nomacs is small, fast and
 able to handle the most common image formats. Additionally it is possible to
 synchronize multiple viewers. A synchronization of viewers running on
 the same computer or via LAN is possible. It allows one to compare images
 and spot the differences (e.g. schemes of architects to show the
 progress).

Package: nomacs-l10n
Architecture: all
Multi-Arch: foreign
Section: localization
Depends: ${misc:Depends}
Replaces: nomacs (<< 3.4.1~)
Description: image viewer with capability of syncing multiple instances (data)
 nomacs is a free image viewer for Windows and Linux systems, which is
 licensed under the GNU General Public License v3. nomacs is small, fast and
 able to handle the most common image formats. Additionally it is possible to
 synchronize multiple viewers. A synchronization of viewers running on
 the same computer or via LAN is possible. It allows one to compare images
 and spot the differences (e.g. schemes of architects to show the
 progress).
 .
 This package provides the nomacs translations.

## nomacs 3.17.2295+dfsg

=== ImageLounge/CMakeLists.txt ===
--- 
+++ 
@@ -96,6 +96,17 @@
 
 # find Qt
 NMC_FINDQT()
+if(${QT_VERSION_MAJOR} VERSION_GREATER_EQUAL "6")
+    # Still we a using a tons of deprecated features (silence them for a while)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
+
+	set(ENABLE_QUAZIP OFF)
+	message(STATUS "QuaZip disabled - it's not supported for Qt6")
+
+    # We need these to biuld with Qt6
+    set(CMAKE_CXX_STANDARD 17)
+    set(CMAKE_CXX_STANDARD_REQUIRED ON)
+endif()
 
 if (NOT ENABLE_QT_DEBUG)
 	message (STATUS "disabling qt debug messages")
@@ -151,18 +162,49 @@
 	LIST(REMOVE_ITEM GUI_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/src/DkPluginManager.h)
 ENDIF(NOT ENABLE_PLUGINS)
 
+# Try to get revision from Git head
+set(NOMACS_REVISION "")
+
+if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../.git)
+	execute_process(COMMAND git rev-parse --short HEAD
+		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+		OUTPUT_VARIABLE NOMACS_REVISION_HASH
+		OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+	execute_process(COMMAND git log -n 1 --pretty=%cd --date=short
+		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+		OUTPUT_VARIABLE NOMACS_REVISION_DATE
+		OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+	set(NOMACS_REVISION "${NOMACS_REVISION_HASH}, ${NOMACS_REVISION_DATE}")
+
+	execute_process(COMMAND git diff-index --quiet HEAD ${CMAKE_CURRENT_SOURCE_DIR}/src
+		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+		RESULT_VARIABLE NOMACS_SRC_MODIFIED
+		ERROR_QUIET)
+
+	if(NOT NOMACS_SRC_MODIFIED EQUAL 0) 
+		set(NOMACS_REVISION "${NOMACS_REVISION}, custom")
+	endif()
+endif()
+
+message("revision is " ${NOMACS_REVISION})
+
+
 # create version file
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/DkCore/DkVersion.h.in ${CMAKE_CURRENT_BINARY_DIR}/DkVersion.h)
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/DkCore/DkVersion.cpp.in ${CMAKE_CURRENT_BINARY_DIR}/src/DkCore/DkVersion.cpp)
+list(APPEND CORE_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/src/DkCore/DkVersion.cpp)
 
 set(NOMACS_FORMS src/nomacs.ui)
 set(NOMACS_RESOURCES src/nomacs.qrc)
 
 file(GLOB NOMACS_TRANSLATIONS "translations/*.ts")
 
-QT5_ADD_RESOURCES(NOMACS_RCC ${NOMACS_RESOURCES})
+qt_add_resources(NOMACS_RCC ${NOMACS_RESOURCES})
 
 if (${ENABLE_TRANSLATIONS})
-	QT5_ADD_TRANSLATION(NOMACS_QM ${NOMACS_TRANSLATIONS})
+	qt_add_translation(NOMACS_QM ${NOMACS_TRANSLATIONS})
 endif()
 
 if(MSVC)
@@ -254,8 +296,7 @@
 MESSAGE(STATUS "")
 MESSAGE(STATUS "----------------------------------------------------------------------------------")
 MESSAGE(STATUS " ${PROJECT_NAME} - Image Lounge ${NOMACS_VERSION}  <https://nomacs.org>")
-execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_VERSION OUTPUT_VARIABLE qt_version)
-message(STATUS " Qt version: ${qt_version}")
+message(STATUS " Qt version: ${Qt${QT_DEFAULT_MAJOR_VERSION}_VERSION}")
 
 
 IF(OpenCV_FOUND)

=== debian/changelog ===
nomacs (3.17.2295+dfsg-0.1~mx21+1) mx; urgency=medium

  * New upstream release.
  * Move nomacs-l10n to Depends.
  * Disable patch.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 26 Mar 2024 15:14:10 -0700

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: nomacs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: LXQt Packaging Team <team+lxqt@tracker.debian.org>
 Uploaders: Alf Gaida <agaida@siduction.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Andrew Lee (李健秋) <ajqlee@debian.org>
 Section: graphics
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
-               cmake,
+Build-Depends: cmake,
+               debhelper-compat (= 13),
                lcov,
                libexiv2-dev,
                liblcms2-dev,
@@ -28,16 +28,16 @@
 
 Package: nomacs
 Architecture: any
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         qt5-image-formats-plugins
+Depends: nomacs-l10n (= ${source:Version}),
+         qt5-image-formats-plugins,
+         ${misc:Depends}, ${shlibs:Depends}
 Breaks: libnomacscore3 (<< 3.6.1),
         libnomacsgui3 (<< 3.6.1),
         libnomacsloader3 (<< 3.6.1)
 Replaces: libnomacscore3 (<< 3.6.1),
           libnomacsgui3 (<< 3.6.1),
           libnomacsloader3 (<< 3.6.1)
-Recommends: nomacs-l10n (= ${source:Version})
+# Recommends: qt5-avif-image-plugin, qt5-heif-image-plugin
 Description: image viewer with capability of syncing multiple instances
  nomacs is a free image viewer for Windows and Linux systems, which is
  licensed under the GNU General Public License v3. nomacs is small, fast and

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export QT_SELECT=5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@} --buildsystem=cmake --sourcedirectory=ImageLounge

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_OPENCV=ON \
		-DENABLE_RAW=ON \
		-DENABLE_TIFF=ON \
		-DENABLE_QT_DEBUG=ON \
		-DENABLE_TRANSLATIONS=ON \
		-DENABLE_READ_BUILD=ON \
		-DENABLE_PLUGINS=OFF \
		-DENABLE_QUAZIP=ON \
		-DUSE_SYSTEM_QUAZIP=ON \
		-DLIB_SUFFIX="/nomacs" \
		-DCMAKE_INSTALL_RPATH="/usr/lib/nomacs" \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_makeshlibs:
		#do nothing

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

## nomacs 3.19.0

=== ImageLounge/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 # needed for soname
 set(NOMACS_VERSION_MAJOR 3)
-set(NOMACS_VERSION_MINOR 17)
+set(NOMACS_VERSION_MINOR 19)
 set(NOMACS_VERSION_PATCH 0)
 set(NOMACS_VERSION ${NOMACS_VERSION_MAJOR}.${NOMACS_VERSION_MINOR})
 set(NOMACS_FULL_VERSION ${NOMACS_VERSION}.${NOMACS_VERSION_PATCH})
@@ -40,7 +40,7 @@
 option(ENABLE_RAW "Compile with raw images support (libraw)" ON)
 option(ENABLE_TIFF "Compile with multi-layer tiff" ON)
 option(ENABLE_QT_DEBUG "Disable Qt Debug Messages" ON)
-option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" ON)
+option(ENABLE_QUAZIP "Compile with QuaZip (allows opening .zip files)" OFF)
 option(ENABLE_INCREMENTER "Run Build Incrementer" OFF)
 option(ENABLE_TRANSLATIONS "Compile Translations" ON)
 option(ENABLE_PLUGINS "Compile nomacs with plugin support" ON)
@@ -82,7 +82,7 @@
 CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
 CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
 if(COMPILER_SUPPORTS_CXX11)
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 elseif(COMPILER_SUPPORTS_CXX0X)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
 elseif(NOT MSVC)
@@ -98,10 +98,9 @@
 NMC_FINDQT()
 if(${QT_VERSION_MAJOR} VERSION_GREATER_EQUAL "6")
     # Still we a using a tons of deprecated features (silence them for a while)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
-
-	set(ENABLE_QUAZIP OFF)
-	message(STATUS "QuaZip disabled - it's not supported for Qt6")
+    if(NOT MSVC)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
+    endif()
 
     # We need these to biuld with Qt6
     set(CMAKE_CXX_STANDARD 17)
@@ -119,6 +118,8 @@
 	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Mac.cmake)
 elseif(UNIX)
 	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
+elseif(MINGW)
+  include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Mingw.cmake)
 else()
 	message(STATUS "build system unkown ... fallback to unix")
 	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
@@ -208,9 +209,15 @@
 endif()
 
 if(MSVC)
-	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/WinBuildTarget.cmake)
+    if (QT_VERSION_MAJOR STREQUAL "5")
+        include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/WinBuildTarget.cmake)
+    else()
+        include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/WinBuildTarget-qt6.cmake)
+    endif()
 elseif(APPLE)
 	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/MacBuildTarget.cmake)
+elseif(MINGW)
+  include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/MingwBuildTarget.cmake)
 elseif(UNIX)
 	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/UnixBuildTarget.cmake)
 else()

=== debian/changelog ===
nomacs (3.19.0-0.1~mx23+1) mx; urgency=medium

  * Import new test release.
  * Refresh patches.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 02 Aug 2024 11:40:05 -0700

nomacs (3.17.2206+git20230315-0mx23+1) mx; urgency=medium

  * Disable automatic file saving for EXIF rotations

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 11 Apr 2023 20:44:12 -0400

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export QT_SELECT=5
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -pthread
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@} --buildsystem=cmake --builddir=build

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	mkdir build
	cd build && cmake -DENABLE_HEIF=ON \
		-DENABLE_OPENCV=ON \
		-DENABLE_RAW=ON \
		-DENABLE_TIFF=ON \
		-DENABLE_QT_DEBUG=ON \
		-DENABLE_TRANSLATIONS=TRUE \
		-DENABLE_READ_BUILD=ON \
		-DENABLE_PLUGINS=OFF \
		-DENABLE_QUAZIP=ON \
		-DLIB_SUFFIX="/nomacs" \
		-DCMAKE_INSTALL_RPATH="/usr/lib/nomacs" \
		-DCMAKE_INSTALL_PREFIX="/usr" \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DUSE_SYSTEM_QUAZIP=ON ../ImageLounge .

override_dh_auto_clean:
	rm -rf build
	dh_auto_clean
	
#override_dh_makeshlibs:
		#do nothing

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## nomacs 3.19.1%2Bdfsg

=== debian/changelog ===
nomacs (3.19.1+dfsg-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 29 Dec 2024 16:23:17 -0800

nomacs (3.19.1+dfsg-1) unstable; urgency=medium

  * New upstream version 3.19.1+dfsg (Closes: #974616, #1081086)
  * Remove unused patch.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 09 Dec 2024 01:40:48 +0800

## nomacs 3.19.1+dfsg

=== ImageLounge/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 
 # check cmake requirements
-cmake_minimum_required (VERSION 3.0)
+cmake_minimum_required (VERSION 3.10)
 
 if(COMMAND cmake_policy)
 	cmake_policy(SET CMP0003 NEW)
@@ -12,7 +12,7 @@
 # needed for soname
 set(NOMACS_VERSION_MAJOR 3)
 set(NOMACS_VERSION_MINOR 19)
-set(NOMACS_VERSION_PATCH 0)
+set(NOMACS_VERSION_PATCH 1)
 set(NOMACS_VERSION ${NOMACS_VERSION_MAJOR}.${NOMACS_VERSION_MINOR})
 set(NOMACS_FULL_VERSION ${NOMACS_VERSION}.${NOMACS_VERSION_PATCH})
 
@@ -48,17 +48,13 @@
 option(ENABLE_AVIF "Compile nomacs with AVIF support" OFF)
 option(ENABLE_JXL "Compile nomacs with JPEG XL support" OFF)
 option(ENABLE_CODE_COV "Run Code Coverage tests" OFF)
+option(ENABLE_TESTING "Run tests" ON)
 option(USE_SYSTEM_QUAZIP "QuaZip will not be compiled from source" ON) # ignored by MSVC
 
 # Codecov
 if (ENABLE_CODE_COV AND CMAKE_COMPILER_IS_GNUCXX)
     include("cmake/CodeCoverage.cmake")
     setup_target_for_coverage(${PROJECT_NAME}_coverage tests coverage)
-endif()
-
-if(APPLE)
-	set(ENABLE_QUAZIP OFF)
-	message(STATUS "QuaZip disabled - it's not supported on OSX")
 endif()
 
 # load paths from the user file if exists
@@ -78,16 +74,8 @@
     endif()
 endif()
 
-include(CheckCXXCompilerFlag)
-CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
-CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
-if(COMPILER_SUPPORTS_CXX11)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
-elseif(COMPILER_SUPPORTS_CXX0X)
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
-elseif(NOT MSVC)
-	message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
-endif()
+set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 if (ENABLE_CODE_COV AND CMAKE_COMPILER_IS_GNUCXX)
 	# Codecov
@@ -125,6 +113,20 @@
 	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
 endif()
 
+if (ENABLE_TESTING AND NOT UNIX) 
+	set(ENABLE_TESTING OFF)
+	message(WARNING "testing is only supported on unix")
+elseif (ENABLE_TESTING)
+	find_package(GTest)
+	if(GTEST_FOUND)
+		enable_testing()
+		add_subdirectory(tests EXCLUDE_FROM_ALL)
+	else()
+		set(ENABLE_TESTING OFF)
+		message(WARNING "GTest not found, disabling testing.")
+	endif()
+endif()
+
 file(GLOB NOMACS_EXE_SOURCES "src/*.cpp")
 file(GLOB NOMACS_EXE_HEADERS "src/*.h")
 
@@ -135,6 +137,9 @@
 # core
 file(GLOB CORE_SOURCES "src/DkCore/*.cpp")
 file(GLOB CORE_HEADERS "src/DkCore/*.h")
+
+# themes
+file(GLOB NOMACS_THEMES "src/themes/*.css")
 
 # gather information for building
 include_directories (
@@ -348,4 +353,7 @@
     MESSAGE(STATUS " nomacs will be compiled with QuaZip support .................. NO")
 ENDIF()
 
-MESSAGE(STATUS "----------------------------------------------------------------------------------")
+IF(ENABLE_TESTING)
+    MESSAGE(STATUS " nomacs tests ................................................. YES")
+ELSE()
+    MESSAGE(STATUS " nomacs tests ................................................. NO")

=== ImageLounge/3rdparty/libqpsd/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(qpsd)

# load paths from the user file if exists
if (EXISTS ${CMAKE_SOURCE_DIR}/CMakeUserPaths.cmake)
  include(${CMAKE_SOURCE_DIR}/CMakeUserPaths.cmake)
		
	message(STATUS "using user paths...")
elseif(MSVC)
	message(WARNING "Could not find CMakeUserPaths.cmake - please use this file to specify your install directories (see CMakeUserPathsGit.cmake)")
endif()

# locate qmake
if(NOT QT_QMAKE_EXECUTABLE)
  find_program(QT_QMAKE_EXECUTABLE NAMES "qmake" "qmake-qt5" "qmake.exe")
endif()
if(NOT QT_QMAKE_EXECUTABLE)
  message(FATAL_ERROR "you have to set the path to the Qt5 qmake executable in CMakeUserPaths.cmake")
else()
  message(STATUS "QMake found: ${QT_QMAKE_EXECUTABLE}")
endif()

get_filename_component(QT_QMAKE_PATH ${QT_QMAKE_EXECUTABLE} PATH)

set(QT_ROOT ${QT_QMAKE_PATH}/)
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${QT_QMAKE_PATH}/../lib/cmake/Qt5)

find_package(Qt5 COMPONENTS Core Gui REQUIRED)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

file(GLOB LIBQPSD_SOURCES "*.cpp")
file(GLOB LIBQPSD_HEADERS "*.h")

SET(CMAKE_DEBUG_POSTFIX "d")

add_library(${PROJECT_NAME} MODULE ${LIBQPSD_SOURCES} ${LIBQPSD_HEADERS})
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Gui)

set_target_properties(${PROJECT_NAME} PROPERTIES ARCHIVE_OUTPUT_DIRECTORY_DEBUG ${CMAKE_CURRENT_BINARY_DIR}/libs)
set_target_properties(${PROJECT_NAME} PROPERTIES ARCHIVE_OUTPUT_DIRECTORY_RELEASE ${CMAKE_CURRENT_BINARY_DIR}/libs)
set_target_properties(${PROJECT_NAME} PROPERTIES ARCHIVE_OUTPUT_DIRECTORY_REALLYRELEASE ${CMAKE_CURRENT_BINARY_DIR}/libs)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/imageformats")

# install to qt plugins dir
execute_process(
  COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PLUGINS
  OUTPUT_VARIABLE QT_PLUGINS_DIR
  OUTPUT_STRIP_TRAILING_WHITESPACE)

if (QT_PLUGINS_DIR)

  # status
  message(STATUS "")
  message(STATUS "-----------------------------------------------------------------------------")
  message(STATUS " ${PROJECT_NAME} configured")
  message(STATUS " <https://github.com/Code-ReaQtor/libqpsd>")
  message(STATUS " it will be installed to ${QT_PLUGINS_DIR}/imageformats")
  message(STATUS "-----------------------------------------------------------------------------")
  
else ()
  message(FATAL_ERROR "Qt5 plugin directory cannot be detected.")
endif ()

# Prefix with DESTDIR if available to allow packaging
if (ENV{DESTDIR} AND NOT ENV{DESTDIR} STREQUAL "")
  set(plugins_dir "$ENV{DESTDIR}${QT_PLUGINS_DIR}")
else ()
  set(plugins_dir "${QT_PLUGINS_DIR}")
endif ()

install(
  TARGETS ${PROJECT_NAME}
  LIBRARY DESTINATION "${plugins_dir}/imageformats")

=== debian/changelog ===
nomacs (3.19.1+dfsg-1build1) plucky; urgency=medium

  * No-change rebuild for opencv 4.10.0.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 19 Feb 2025 08:45:02 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: nomacs
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: LXQt Packaging Team <team+lxqt@tracker.debian.org>
+Maintainer: LXQt Packaging Team <team+lxqt@tracker.debian.org>
 Uploaders: Alf Gaida <agaida@siduction.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Andrew Lee (李健秋) <ajqlee@debian.org>
 Section: graphics
 Priority: optional
-Build-Depends: cmake,
-               debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 13),
+               cmake,
                lcov,
                libexiv2-dev,
                liblcms2-dev,
@@ -28,16 +27,16 @@
 
 Package: nomacs
 Architecture: any
-Depends: nomacs-l10n (= ${source:Version}),
-         qt5-image-formats-plugins,
-         ${misc:Depends}, ${shlibs:Depends}
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         qt5-image-formats-plugins
 Breaks: libnomacscore3 (<< 3.6.1),
         libnomacsgui3 (<< 3.6.1),
         libnomacsloader3 (<< 3.6.1)
 Replaces: libnomacscore3 (<< 3.6.1),
           libnomacsgui3 (<< 3.6.1),
           libnomacsloader3 (<< 3.6.1)
-# Recommends: qt5-avif-image-plugin, qt5-heif-image-plugin
+Recommends: nomacs-l10n (= ${source:Version})
 Description: image viewer with capability of syncing multiple instances
  nomacs is a free image viewer for Windows and Linux systems, which is
  licensed under the GNU General Public License v3. nomacs is small, fast and

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export QT_SELECT=5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@} --buildsystem=cmake --sourcedirectory=ImageLounge

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_OPENCV=ON \
		-DENABLE_RAW=ON \
		-DENABLE_TIFF=ON \
		-DENABLE_QT_DEBUG=ON \
		-DENABLE_TRANSLATIONS=ON \
		-DENABLE_READ_BUILD=ON \
		-DENABLE_PLUGINS=OFF \
		-DENABLE_QUAZIP=ON \
		-DUSE_SYSTEM_QUAZIP=ON \
		-DLIB_SUFFIX="/nomacs" \
		-DCMAKE_INSTALL_RPATH="/usr/lib/nomacs" \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_makeshlibs:
		#do nothing

## nomacs 3.21.0+dfsg

=== ImageLounge/CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,8 @@
 
 # needed for soname
 set(NOMACS_VERSION_MAJOR 3)
-set(NOMACS_VERSION_MINOR 19)
-set(NOMACS_VERSION_PATCH 1)
+set(NOMACS_VERSION_MINOR 21)
+set(NOMACS_VERSION_PATCH 0)
 set(NOMACS_VERSION ${NOMACS_VERSION_MAJOR}.${NOMACS_VERSION_MINOR})
 set(NOMACS_FULL_VERSION ${NOMACS_VERSION}.${NOMACS_VERSION_PATCH})
 
@@ -47,8 +47,10 @@
 option(ENABLE_HEIF "Compile nomacs with HEIF support" OFF)
 option(ENABLE_AVIF "Compile nomacs with AVIF support" OFF)
 option(ENABLE_JXL "Compile nomacs with JPEG XL support" OFF)
+option(ENABLE_JXR "Download JPEG XR plug-in" OFF)
 option(ENABLE_CODE_COV "Run Code Coverage tests" OFF)
 option(ENABLE_TESTING "Run tests" ON)
+option(ENABLE_BENCHMARK "Run benchmark" OFF)
 option(USE_SYSTEM_QUAZIP "QuaZip will not be compiled from source" ON) # ignored by MSVC
 
 # Codecov
@@ -124,6 +126,19 @@
 	else()
 		set(ENABLE_TESTING OFF)
 		message(WARNING "GTest not found, disabling testing.")
+	endif()
+endif()
+
+if (ENABLE_BENCHMARK AND NOT UNIX) 
+	set(ENABLE_BENCHMARK OFF)
+	message(WARNING "benchmark is only supported on unix")
+elseif (ENABLE_BENCHMARK)
+	find_package(benchmark)
+	if(benchmark_FOUND)
+		add_subdirectory(benchmarks EXCLUDE_FROM_ALL)
+	else()
+		set(ENABLE_BENCHMARK OFF)
+		message(WARNING "benchmark not found, disabling benchmark.")
 	endif()
 endif()
 
@@ -194,7 +209,7 @@
 	endif()
 endif()
 
-message("revision is " ${NOMACS_REVISION})
+message(STATUS "revision is " ${NOMACS_REVISION})
 
 
 # create version file
@@ -230,36 +245,46 @@
 	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/UnixBuildTarget.cmake)
 endif()
 
+# get the version stored in version.cache
+file(READ ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/utils/version.cache NOMACS_CACHED_VERSION)
+string(STRIP "${NOMACS_CACHED_VERSION}" NOMACS_CACHED_VERSION)
+string(REGEX MATCH "^version:(.*)$" HAS_MATCH ${NOMACS_CACHED_VERSION})
+if (HAS_MATCH)
+  set(NOMACS_CACHED_VERSION ${CMAKE_MATCH_1})
+else()
+  message(FATAL_ERROR "I could not parse version.cache")
+endif()
+
 # add build incrementer command if requested
 if (ENABLE_INCREMENTER AND Python_FOUND)
 
     add_custom_command(
         TARGET ${DLL_CORE_NAME} PRE_BUILD 
         COMMAND ${Python_EXECUTABLE}
-        ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionincrement.py 
+        ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionincrement.py
         ${NOMACS_VERSION})
 
-    message(STATUS "build incrementer enabled...")
-
-endif()
-
-if (Python_FOUND)
-    
     add_custom_command(
-        TARGET ${DLL_CORE_NAME} PRE_BUILD 
+        TARGET ${DLL_CORE_NAME} PRE_BUILD
         COMMAND ${Python_EXECUTABLE}
-        ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionupdate.py 
+        ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionupdate.py
         ${CMAKE_BINARY_DIR}/DkVersion.h)
 
     # I am having issues with the PRE_BUILD above
     # if version increment is off, we just need to run the update once (for version won't change)
     # so let's do that:
-    execute_process(COMMAND ${Python_EXECUTABLE}
-            ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionupdate.py 
-            ${CMAKE_BINARY_DIR}/DkVersion.h)
-
-else()
-    message(WARNING "Python not found: the version number will be incorrect!")
+    execute_process(
+        COMMAND ${Python_EXECUTABLE}
+        ${CMAKE_CURRENT_SOURCE_DIR}/../scripts/versionupdate.py
+        ${CMAKE_BINARY_DIR}/DkVersion.h)
+
+    message(WARNING "build incrementer enabled, using version.cache: \"${NOMACS_CACHED_VERSION}\"")
+else()
+  # NOTE: the appveyor windows builds rely on version.cache for the installer and msi version numbers
+  if (NOT NOMACS_CACHED_VERSION STREQUAL NOMACS_FULL_VERSION)
+    message(FATAL_ERROR "version.cache mismatch \"${NOMACS_CACHED_VERSION}\", it should be ${NOMACS_FULL_VERSION}")
+  endif()
+  message(STATUS "nomacs version is ${NOMACS_FULL_VERSION}")
 endif()
 
 
@@ -326,34 +351,3 @@
 IF(ENABLE_TIFF)
     MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... YES")
 ELSE()
-    MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... NO")
-ENDIF()
-
-IF(ENABLE_PLUGINS)
-    MESSAGE(STATUS " nomacs will be compiled with plugin support .................. YES")
-ELSE()
-    MESSAGE(STATUS " nomacs will be compiled with plugin support .................. NO")
-ENDIF()
-
-IF(libheif_FOUND)
-    MESSAGE(STATUS " nomacs will be compiled with HEIF support .................... YES")
-ELSE()
-    MESSAGE(STATUS " nomacs will be compiled with HEIF support .................... NO")
-ENDIF()
-
-IF(ENABLE_TRANSLATIONS)
-    MESSAGE(STATUS " nomacs will be compiled with Translations .................... YES")
-ELSE()
-    MESSAGE(STATUS " nomacs will be compiled with Translations .................... NO")
-ENDIF()
-
-IF(ENABLE_QUAZIP)
-    MESSAGE(STATUS " nomacs will be compiled with QuaZip support .................. YES")
-ELSE()
-    MESSAGE(STATUS " nomacs will be compiled with QuaZip support .................. NO")
-ENDIF()
-
-IF(ENABLE_TESTING)
-    MESSAGE(STATUS " nomacs tests ................................................. YES")
-ELSE()
-    MESSAGE(STATUS " nomacs tests ................................................. NO")

=== ImageLounge/tests/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/DkCore)

add_executable(core_tests DkUtils_test.cpp)

target_link_libraries(
    core_tests
    nomacsCore
    ${OpenCV_LIBS}
    GTest::gtest_main
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
)

add_custom_target(
    check
    COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
    DEPENDS core_tests
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

include(GoogleTest)
gtest_discover_tests(core_tests)

=== debian/changelog ===
nomacs (3.21.0+dfsg-2) unstable; urgency=medium

  * Clean up of group membership after 2nd calls.
  * debian/control: depends on qt6-image-formats-plugins instead of
    qt5-image-formats-plugins.
  * Run wrap-and-sort.
  * debian/copyright: update.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Mon, 21 Apr 2025 10:09:01 +0200

nomacs (3.21.0+dfsg-1) unstable; urgency=medium

  * New upstream version 3.21.0+dfsg.
  * Use Qt6.
  * d/copyright: Update copyright year.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 30 Mar 2025 23:50:03 +0800

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,20 @@
 Source: nomacs
 Maintainer: LXQt Packaging Team <team+lxqt@tracker.debian.org>
-Uploaders: Alf Gaida <agaida@siduction.org>,
-           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
+Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Andrew Lee (李健秋) <ajqlee@debian.org>
 Section: graphics
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
-               cmake,
+Build-Depends: cmake,
+               debhelper-compat (= 13),
                lcov,
                libexiv2-dev,
-               liblcms2-dev,
                libopencv-dev,
-               libqt5svg5-dev,
-               libquazip5-dev,
+               libquazip1-qt6-dev,
                libraw-dev,
-               libtiff-dev,
-               libwebp-dev,
-               qt5-qmake,
-               qttools5-dev,
-               qttools5-dev-tools
+               qt6-base-dev,
+               qt6-image-formats-plugins,
+               qt6-svg-dev,
+               qt6-tools-dev
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/lxqt-team/nomacs
 Vcs-Git: https://salsa.debian.org/lxqt-team/nomacs.git
@@ -27,9 +23,7 @@
 
 Package: nomacs
 Architecture: any
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         qt5-image-formats-plugins
+Depends: qt6-image-formats-plugins, ${misc:Depends}, ${shlibs:Depends}
 Breaks: libnomacscore3 (<< 3.6.1),
         libnomacsgui3 (<< 3.6.1),
         libnomacsloader3 (<< 3.6.1)

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export QT_SELECT=5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@} --buildsystem=cmake --sourcedirectory=ImageLounge

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_INSTALL_RPATH="/usr/lib/nomacs" \
		-DENABLE_HEIF=OFF \
		-DENABLE_OPENCV=ON \
		-DENABLE_PLUGINS=OFF \
		-DENABLE_QT_DEBUG=ON \
		-DENABLE_QUAZIP=ON \
		-DENABLE_RAW=ON \
		-DENABLE_READ_BUILD=ON \
		-DENABLE_TESTING=OFF \
		-DENABLE_TIFF=ON \
		-DENABLE_TRANSLATIONS=ON \
		-DLIB_SUFFIX="/nomacs" \
		-DQT_VERSION_MAJOR=6 \
		-DUSE_SYSTEM_QUAZIP=ON

override_dh_makeshlibs:
		#do nothing

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=auto" \
https://github.com/nomacs/nomacs/tags .*/@ANY_VERSION@@ARCHIVE_EXT@

## nomacs 3.21.1%2Bdfsg

=== ImageLounge/benchmarks/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/DkCore)

add_executable(core_benchmarks DkImageStorage_bench.cpp)

target_link_libraries(
    core_benchmarks
    nomacsCore
    ${OpenCV_LIBS}
    benchmark::benchmark
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
)

add_custom_target(
    bench
    COMMAND core_benchmarks
    DEPENDS core_benchmarks
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

## nomacs 3.21.1+dfsg

=== ImageLounge/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 # needed for soname
 set(NOMACS_VERSION_MAJOR 3)
 set(NOMACS_VERSION_MINOR 21)
-set(NOMACS_VERSION_PATCH 0)
+set(NOMACS_VERSION_PATCH 1)
 set(NOMACS_VERSION ${NOMACS_VERSION_MAJOR}.${NOMACS_VERSION_MINOR})
 set(NOMACS_FULL_VERSION ${NOMACS_VERSION}.${NOMACS_VERSION_PATCH})
 
@@ -44,14 +44,15 @@
 option(ENABLE_INCREMENTER "Run Build Incrementer" OFF)
 option(ENABLE_TRANSLATIONS "Compile Translations" ON)
 option(ENABLE_PLUGINS "Compile nomacs with plugin support" ON)
-option(ENABLE_HEIF "Compile nomacs with HEIF support" OFF)
-option(ENABLE_AVIF "Compile nomacs with AVIF support" OFF)
-option(ENABLE_JXL "Compile nomacs with JPEG XL support" OFF)
-option(ENABLE_JXR "Download JPEG XR plug-in" OFF)
+option(ENABLE_HEIF "Download HEIF plug-in (Windows only)" OFF)
+option(ENABLE_AVIF "Download AVIF plug-in (Windows only)" OFF)
+option(ENABLE_JXL "Download JPEG XL plug-in (Windows only)" OFF)
+option(ENABLE_JXR "Download JPEG XR plug-in (Windows only)" OFF)
 option(ENABLE_CODE_COV "Run Code Coverage tests" OFF)
 option(ENABLE_TESTING "Run tests" ON)
 option(ENABLE_BENCHMARK "Run benchmark" OFF)
 option(USE_SYSTEM_QUAZIP "QuaZip will not be compiled from source" ON) # ignored by MSVC
+option(ENABLE_PCH "Enable precompiled headers" OFF)
 
 # Codecov
 if (ENABLE_CODE_COV AND CMAKE_COMPILER_IS_GNUCXX)
@@ -113,33 +114,6 @@
 else()
 	message(STATUS "build system unkown ... fallback to unix")
 	include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/Unix.cmake)
-endif()
-
-if (ENABLE_TESTING AND NOT UNIX) 
-	set(ENABLE_TESTING OFF)
-	message(WARNING "testing is only supported on unix")
-elseif (ENABLE_TESTING)
-	find_package(GTest)
-	if(GTEST_FOUND)
-		enable_testing()
-		add_subdirectory(tests EXCLUDE_FROM_ALL)
-	else()
-		set(ENABLE_TESTING OFF)
-		message(WARNING "GTest not found, disabling testing.")
-	endif()
-endif()
-
-if (ENABLE_BENCHMARK AND NOT UNIX) 
-	set(ENABLE_BENCHMARK OFF)
-	message(WARNING "benchmark is only supported on unix")
-elseif (ENABLE_BENCHMARK)
-	find_package(benchmark)
-	if(benchmark_FOUND)
-		add_subdirectory(benchmarks EXCLUDE_FROM_ALL)
-	else()
-		set(ENABLE_BENCHMARK OFF)
-		message(WARNING "benchmark not found, disabling benchmark.")
-	endif()
 endif()
 
 file(GLOB NOMACS_EXE_SOURCES "src/*.cpp")
@@ -255,6 +229,11 @@
   message(FATAL_ERROR "I could not parse version.cache")
 endif()
 
+if (ENABLE_PCH)
+	target_precompile_headers(${DLL_CORE_NAME} PRIVATE $<$<COMPILE_LANGUAGE:CXX>:prefix.h>)
+	message(WARNING "!!Precompiled header should only be used for development!!")
+endif()
+
 # add build incrementer command if requested
 if (ENABLE_INCREMENTER AND Python_FOUND)
 
@@ -287,7 +266,6 @@
   message(STATUS "nomacs version is ${NOMACS_FULL_VERSION}")
 endif()
 
-
 NMC_INSTALL()
 
 NMC_COPY_FILES()
@@ -318,10 +296,41 @@
 		set(NOMACS_FOUND true)
 		set(NOMACS_VARS_ALREADY_SET true)
 		add_subdirectory(${PLUGINS_DIR} "${CMAKE_CURRENT_BINARY_DIR}/plugins")
+
+		if(APPLE)
+			NMC_BUNDLE_COPY_PLUGINS()
+		endif()
 	else()
 		message(STATUS "I failed to locate plugins in: ${PLUGINS_DIR}")
 		message(WARNING "plugins directory not found, not building plugins. You have to check out the nomacs-plugins git to the 'plugins' folder if you want to build them")
 		SET(ENABLE_PLUGINS OFF)
+	endif()
+endif()
+
+if (ENABLE_TESTING AND NOT UNIX)
+	set(ENABLE_TESTING OFF)
+	message(WARNING "testing is only supported on unix")
+elseif (ENABLE_TESTING)
+	find_package(GTest)
+	if(GTEST_FOUND)
+		enable_testing()
+		add_subdirectory(tests EXCLUDE_FROM_ALL)
+	else()
+		set(ENABLE_TESTING OFF)
+		message(WARNING "GTest not found, disabling testing.")
+	endif()
+endif()
+
+if (ENABLE_BENCHMARK AND NOT UNIX)
+	set(ENABLE_BENCHMARK OFF)
+	message(WARNING "benchmark is only supported on unix")
+elseif (ENABLE_BENCHMARK)
+	find_package(benchmark)
+	if(benchmark_FOUND)
+		add_subdirectory(benchmarks EXCLUDE_FROM_ALL)
+	else()
+		set(ENABLE_BENCHMARK OFF)
+		message(WARNING "benchmark not found, disabling benchmark.")
 	endif()
 endif()
 
@@ -343,11 +352,3 @@
 ENDIF()
 
 IF(LIBRAW_FOUND)
-    MESSAGE(STATUS " nomacs will be compiled with LIBRAW support .................. YES")
-ELSE()
-    MESSAGE(STATUS " nomacs will be compiled with LIBRAW support .................. NO")
-ENDIF()
-
-IF(ENABLE_TIFF)
-    MESSAGE(STATUS " nomacs will be compiled with extended TIFF support ........... YES")
-ELSE()

=== ImageLounge/tests/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 target_link_libraries(
     core_tests
-    nomacsCore
+    ${DLL_CORE_NAME}
     ${OpenCV_LIBS}
     GTest::gtest_main
     Qt${QT_MAJOR_VERSION}::Core
@@ -13,7 +13,10 @@
 
 add_custom_target(
     check
-    COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
+    COMMAND
+        LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/:$ENV{LD_LIBRARY_PATH}
+        DYLD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/:$ENV{DYLD_LIBRARY_PATH}
+        ${CMAKE_CTEST_COMMAND} --output-on-failure
     DEPENDS core_tests
     WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
 )

=== ImageLounge/xgd-data/CMakeLists.txt ===
configure_file(
	org.nomacs.ImageLounge.appdata.xml.in
	org.nomacs.ImageLounge.appdata.xml)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.nomacs.ImageLounge.appdata.xml
	DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)

install(FILES org.nomacs.ImageLounge.desktop
	DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

install(FILES ../nomacs.svg
	DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps
	RENAME org.nomacs.ImageLounge.svg)

=== debian/changelog ===
nomacs (3.21.1+dfsg-1) unstable; urgency=medium

  * New upstream version 3.21.1+dfsg
  * d/contro: Bump Standards-Version to 4.7.2.
  * d/control: Update Build-Depends.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 17 Aug 2025 19:26:10 +0800

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
                debhelper-compat (= 13),
                lcov,
                libexiv2-dev,
+               libheif-dev,
                libopencv-dev,
                libquazip1-qt6-dev,
                libraw-dev,
@@ -15,7 +16,7 @@
                qt6-image-formats-plugins,
                qt6-svg-dev,
                qt6-tools-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/lxqt-team/nomacs
 Vcs-Git: https://salsa.debian.org/lxqt-team/nomacs.git
 Homepage: https://nomacs.org/
